Copyright (C) 2008-2022 Free Software Foundation, Inc.
See the end of the file for license conditions.


Requirements
------------
Mac OS X 10.6 or later

- or -

GNUstep "Startup 0.23" or later
Tested on GNU/Linux, may work on other systems.


Compilation
-----------

In the top-level directory, use:

  ./configure --with-ns

(On macOS, --with-ns is enabled by default.)

Then run:

  make

This will compile all the files.

In order to run Emacs, you must run:

  src/emacs

In order to install Emacs, you must run:

  make install

This will assemble the app in nextstep/Emacs.app (i.e., the --prefix
argument has no effect in this case).  You can then move the Emacs.app
bundle to a location of your choice.

If you pass the --disable-ns-self-contained option to configure, the lisp
files will be installed under whatever 'prefix' is set to (defaults to
/usr/local).  The bundle will be smaller, but depend on these resources (may
require 'sudo' for "make install").


Targeting different macOS versions
----------------------------------

The Emacs build process automatically enables or disables macOS
features according to the version of macOS it is being built on.  It
is possible to override this automatic configuration if you are
targeting a different version of macOS, or wish to build one
executable that is able to enable or disable features at run-time.

To build a version compatible with an older version of macOS use this
flag:

  -DMAC_OS_X_VERSION_MIN_REQUIRED=x

and to build for a newer version of macOS:

  -DMAC_OS_X_VERSION_MAX_ALLOWED=x

For example, to enable run-time checks for features available between
macOS 10.6, and 10.12 inclusive:

  ./configure --with-ns CFLAGS="-DMAC_OS_X_VERSION_MIN_REQUIRED=1060 \
    -DMAC_OS_X_VERSION_MAX_ALLOWED=101200 -g3 -O2"

The macOS version numbers are formatted as 10x0 for macOS up to 10.10,
and 10xx00 for macOS 10.10 and above.  A full list is provided in
/usr/include/AvailabilityMacros.h.


Installation
------------

Move nextstep/Emacs.app to any desired install location.



This file is part of GNU Emacs.

GNU Emacs is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GNU Emacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs.  If not, see <https://www.gnu.org/licenses/>.
